UNIT Graphunit;

INTERFACE

USES
    Windows,
    Messages,
    SysUtils,
    Classes,
    Graphics,
    Controls,
    Forms,
    Dialogs,
    TeeProcs,
    TeEngine,
    Chart,
    ExtCtrls,
    Buttons,
    Menus,
    Series,
    ComCtrls,
    StdCtrls,
    aresources,
    printers;

TYPE
    TForm8=CLASS(TForm)
        Panel2:TPanel;
        PageControl1:TPageControl;
        TabSheet1:TTabSheet;
        Chart1:TChart;
        Series1:TFastLineSeries;
        TabSheet2:TTabSheet;
        SaveDialog1:TSaveDialog;
        Label2:TLabel;
        Label3:TLabel;
        Label4:TLabel;
        Label5:TLabel;
        Label6:TLabel;
        ScrollBox1:TScrollBox;
        Button2:TButton;
        ComboBox1:TComboBox;
        CheckBox1:TCheckBox;
        Image1:TImage;
        SpeedButton1:TSpeedButton;
        Image2:TImage;
        Button3:TButton;
        Button1:TButton;
        ProgressBar1:TProgressBar;
        Button4:TButton;
        PROCEDURE FormCreate(Sender:TObject);
        PROCEDURE SpeedButton1Click(Sender:TObject);
        PROCEDURE Chart1MouseMove(Sender:TObject;Shift:TShiftState;X, Y:Integer);
        PROCEDURE Calc;
        PROCEDURE Plot(newMAC:single);
        PROCEDURE Button1Click(Sender:TObject);
        PROCEDURE Image1DblClick(Sender:TObject);
        PROCEDURE Button2Click(Sender:TObject);
        PROCEDURE Chart1DblClick(Sender:TObject);
        PROCEDURE Button4Click(Sender:TObject);
    PRIVATE
    { Private declarations }
    PUBLIC
        oldy, oldx:integer;
    { Public declarations }
    END;

VAR
    Form8:TForm8;
    vvert_dotsmax,
        vhorz_dotsmax:integer;
    rvert_dotsmax,
        rhorz_dotsmax:single;
    pscalex, pscaley:integer;

IMPLEMENTATION

USES mathunit,
    MainUnit1;
{$R *.DFM}

PROCEDURE TForm8.Calc;
VAR
    i:integer;
BEGIN
    form1.debugview(dbg_startfill);
    chart1.BufferedDisplay:=true;
    chart1.LeftAxis.SetMinMax(0, (mathunit.Cm*1000+10)/1000);
    chart1.BottomAxis.SetMinMax(1, length(dataarea));
    chart1.Series[0].addy(0, '', clTeecolor);
    FOR i:=0 TO length(dataarea)-1 DO
        chart1.Series[0].addy(dataarea[i], '', clTeecolor);
    form1.debugview(dbg_endfill);
END;

PROCEDURE TForm8.Plot(newMAC:single);
VAR
    x, y, i, j, k, yoffs, xoffs:integer;
    mixmax:real;
    ccolors:ARRAY[99..300] OF Tcolor;
    schtring:STRING;

    FUNCTION testtrunc(s:single):integer;
    BEGIN
        result:=trunc(s);
        IF result>300 THEN result:=300;
        IF result<100 THEN result:=99;
    END;
BEGIN
    progressbar1.Visible:=true;
    mixmax:=newMAC/100;
    FOR i:=10 TO 210 DO BEGIN
        ccolors[310-i]:=rgb(i, i, i);//over MAC
    END;
    ccolors[99]:=clWhite;//under MAC

    i:=length(dataarea)DIV 10;
    j:=10;
    FOR k:=1 TO 2 DO
        FOR i:=1 TO i DO BEGIN
            WHILE true DO BEGIN
                FRM_Cxy(dataarea[i*10], i*10, j);
                IF (mathunit.Cy>mathunit.MAC) THEN inc(j, 10) ELSE break;
            END;
        END;
    inc(j, 10);
    k:=j;
    image1.Height:=j*2+30;
    image1.Width:=length(dataarea)+30;
    image2.Width:=image1.width DIV(image1.width DIV scrollbox1.Width);
    image2.Height:=trunc(image2.Width/(image1.width/image1.height));
    image2.Width:=2*image2.Width;
    image2.Height:=2*image2.Height;
    yoffs:=j+30;
    xoffs:=30;
    progressbar1.Max:=j;
    FOR j:=0 TO j DO BEGIN
        FOR i:=1 TO length(dataarea)-1 DO BEGIN
            FRM_Cxy(dataarea[i], i, j);
            image1.Canvas.Pixels[xoffs+i, yoffs+j-1]:=ccolors[testtrunc(mathunit.Cy/mixmax)];
            image1.Canvas.Pixels[xoffs+i, yoffs-j]:=ccolors[testtrunc(mathunit.Cy/mixmax)];
            application.ProcessMessages;
        END;
        progressbar1.Position:=j;
        application.ProcessMessages;
    END;
    FOR i:=1 TO 5 DO
        FOR j:=1 TO 5 DO BEGIN
//real case
            image1.Canvas.Pixels[xoffs+trunc(mathunit.Xmn), yoffs-j]:=clRed;
            image1.Canvas.Pixels[xoffs+trunc(mathunit.Xmn), yoffs+j]:=clRed;
            image1.Canvas.Pixels[xoffs+trunc(mathunit.Xmn)-i, yoffs]:=clRed;
            image1.Canvas.Pixels[xoffs+trunc(mathunit.Xmn)+i, yoffs]:=clRed;
//worst case
            image1.Canvas.Pixels[xoffs+trunc(mathunit.Xm), yoffs-j]:=clLime;
            image1.Canvas.Pixels[xoffs+trunc(mathunit.Xm), yoffs+j]:=clLime;
            image1.Canvas.Pixels[xoffs+trunc(mathunit.Xm)-i, yoffs]:=clLime;
            image1.Canvas.Pixels[xoffs+trunc(mathunit.Xm)+i, yoffs]:=clLime;
//source
            image1.Canvas.Pixels[xoffs, yoffs-j]:=clBlue;
            image1.Canvas.Pixels[xoffs, yoffs+j]:=clBlue;
            image1.Canvas.Pixels[xoffs-i, yoffs]:=clBlue;
            image1.Canvas.Pixels[xoffs+i, yoffs]:=clBlue;
        END;
    FOR i:=image1.Width DOWNTO 0 DO BEGIN
        image1.Canvas.Pixels[i, 0]:=clBlack;
        CASE (i-xoffs)MOD 50 OF
            0:
                IF (i-xoffs)>=0 THEN BEGIN
                    image1.Canvas.Pixels[i, 1]:=clBlack;
                    image1.Canvas.Pixels[i, 2]:=clBlack;
                    image1.Canvas.Pixels[i, 3]:=clBlack;
                    schtring:=format('%d', [i-xoffs]);
                    x:=i-(image1.Canvas.TextWidth(schtring)DIV 2);
                    y:=6;
                    IF x+image1.Canvas.TextWidth(schtring)<image1.Width THEN
                        image1.Canvas.TextOut(x, y, schtring);
                END;
        END;
    END;
    FOR i:=image1.Height DOWNTO 0 DO BEGIN
        image1.Canvas.Pixels[0, i]:=clBlack;
        CASE (i-yoffs)MOD 50 OF
            0:
                IF abs(i-yoffs)<=k THEN BEGIN
                    image1.Canvas.Pixels[1, i]:=clBlack;
                    image1.Canvas.Pixels[2, i]:=clBlack;
                    image1.Canvas.Pixels[3, i]:=clBlack;
                    schtring:=format('%d', [abs(i-yoffs)]);
                    x:=6;
                    y:=i-(image1.Canvas.TextHeight(schtring)DIV 2);
                    IF y+image1.Canvas.TextHeight(schtring)<image1.Height THEN
                        image1.Canvas.TextOut(x, y, schtring);
                END;
        END;
    END;
    image1.Canvas.Font.Name:='Courier';
    image1.Canvas.Font.Color:=clRed;
    image1.Canvas.brush.Color:=ccolors[100];
    image1.Canvas.TextOut(30, 20, '  100% of MAC ');
    image1.Canvas.brush.Color:=ccolors[300];
    image1.Canvas.TextOut(30, 35, ' >300% of MAC ');
    image1.Canvas.Font.Color:=clBlack;
    image1.Canvas.brush.Color:=clBlue;
    image1.Canvas.TextOut(30, 50, ' Source       ');
    image1.Canvas.brush.Color:=clRed;
    image1.Canvas.TextOut(30, 65, ' Xm           ');
    image1.Canvas.brush.Color:=clLime;
    image1.Canvas.TextOut(30, 80, ' Xmn          ');
    image2.Picture:=image1.Picture;
    messagebeep(0);
    progressbar1.Visible:=false;
    progressbar1.Position:=0;
    pagecontrol1.ActivePage:=tabsheet2;
END;

PROCEDURE TForm8.FormCreate(Sender:TObject);
VAR
    rect:trect;
BEGIN
    IF systemparametersinfo(SPI_GETWORKAREA, 0, @rect, 0)<>BOOL(0) THEN BEGIN
        self.Left:=rect.Left;
        self.Top:=rect.Top;
        self.Width:=rect.Right-rect.Left;
        self.Height:=rect.Bottom-rect.Top;
    END ELSE BEGIN
        self.Height:=screen.Height;
        self.width:=screen.width;
        self.Top:=0;
        self.Left:=0;
    END;
//client area will align automatically
    oldx:=-1;
    chart1.BufferedDisplay:=true;
    pagecontrol1.ActivePage:=tabsheet1;
    activecontrol:=tabsheet1;
    try
       combobox1.Items:=printer.Printers;
       combobox1.ItemIndex:=printer.PrinterIndex;
    except on exception do begin
           combobox1.Visible:=false;
           checkbox1.Visible:=false;
           button2.Visible:=false;
           combobox1.enabled:=false;
           checkbox1.enabled:=false;
           button2.enabled:=false;
           end;
    end;
    speedbutton1.Left:=self.Left+self.Width-speedbutton1.Width-10;
    calc;
END;

PROCEDURE TForm8.SpeedButton1Click(Sender:TObject);
BEGIN
    closE;
END;

PROCEDURE TForm8.Chart1MouseMove(Sender:TObject;Shift:TShiftState;X, Y:Integer);
VAR
    tmpX, tmpY:Double;
BEGIN
    IF PtInRect(Chart1.ChartRect, Point(X-Chart1.Width3d, Y+Chart1.Height3d)) THEN
        WITH Series1 DO BEGIN
            GetCursorValues(tmpX, tmpY);
            Label6.Caption:=GetVertAxis.LabelValue(tmpY);
            Label5.Caption:=GetHorizAxis.LabelValue(tmpX);
        END;

END;

PROCEDURE TForm8.Button1Click(Sender:TObject);
BEGIN
    plot(mathunit.MAC);
END;

PROCEDURE TForm8.Image1DblClick(Sender:TObject);
BEGIN
    savedialog1.DefaultExt:=bmp_extension;
    savedialog1.Filter:=bmp_filter;
    savedialog1.filename:='MAC_plot.bmp';
    IF savedialog1.Execute THEN BEGIN
        IF fileexists(savedialog1.filename) THEN
            IF messagedlg('The file already exists!'+#13#10+'Overwrite?', mtconfirmation, [mbyes, mbno], 0)=mrno THEN BEGIN
                form1.debugview('Error: Nothing saved. (0)');
                exit;
            END;
        image1.Picture.Bitmap.SaveToFile(savedialog1.filename);
        IF fileexists(savedialog1.filename) THEN form1.debugview('Success: '+savedialog1.FileName+' saved.');
    END;

END;

PROCEDURE TForm8.Button2Click(Sender:TObject);
BEGIN
    IF messagedlg('Do you want to proceed printing? No preview available!', mtconfirmation, [mbyes, mbno], 0)=mryes THEN BEGIN
        printer.PrinterIndex:=combobox1.ItemIndex;
        CASE checkbox1.checked OF
            TRUE:chart1.PrintLandscape;
            FALSE:chart1.PrintPortrait;
        END;
    END;
END;

PROCEDURE TForm8.Chart1DblClick(Sender:TObject);
BEGIN
    savedialog1.DefaultExt:=bmp_extension;
    savedialog1.Filter:=all_filter;
    savedialog1.filename:=bmp_default;
    IF savedialog1.Execute THEN BEGIN
        IF fileexists(savedialog1.filename) THEN
            IF messagedlg(confirm_overw, mtconfirmation, [mbyes, mbno], 0)<>mryes THEN exit;
        CASE savedialog1.FilterIndex OF
            1:chart1.SaveToBitmapFile(savedialog1.filename);
            2:chart1.SaveToMetafile(savedialog1.filename);
            3:chart1.SaveToMetafileEnh(savedialog1.filename);
        END;
        form1.debugview(save_chart_as+savedialog1.filename);
    END;
END;

PROCEDURE TForm8.Button4Click(Sender:TObject);
BEGIN
    tabsheet2.Visible:=false;
    button3.Enabled:=false;
    plot(mathunit.MAC);
    tabsheet2.Visible:=true;
    button3.Enabled:=true;
END;

END.
